<?
/**************************** 
* $RCSfile: smarty_config.php,v $
* $Author: sergey $ (last committer) 
* $Date: 2006/01/26 08:34:31 $ 
* $Revision: 1.20 $ 
****************************/
require_once( $lpath['common'].'smarty/Smarty.class.php' );

$smarty = new Smarty;

$smarty->template_dir = $lpath['tpl'];
$smarty->compile_dir = $lpath['tpl_c'];
if (isset($lpath['tpl_cache']))
	$smarty->cache_dir = $lpath['tpl_cache'];
if (isset($lpath['conf_dir']))
	$smarty->config_dir = $lpath['conf_dir'];



//========= once after changes ==== for emergency measures!!! ============
$smarty->clear_compiled_tpl();
$smarty->clear_all_cache(); 
//___
$smarty->force_compile = true;
//this may slow down the pages, but all changes are recompiled immediately,
// that's more important in development than maximum performance
//================== R.I. =================================================


$smarty->left_delimiter = '{{';
$smarty->right_delimiter = '}}';
$smarty->compile_check = true;
//$smarty->debugging = $ldebug['smarty'];
$smarty->caching = false;
$smarty->cache_lifetime = 0;

$smarty->assign('host', $lpath['host']);
$smarty->assign('path', $lpath['url']);
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * Author:   Sergey Kalchenko
 * Type:     modifier
 * Name:     thousand
 * Purpose:     
 * Arguments: 
 *           - -,
 *           - ,
 *           -  ('', 'k', 'm', 'g'),
 *           -     
 * Example:  {{1234567890|thousand:"'":'k':2}} -> 1'205'632.71k
 * -------------------------------------------------------------
 */
function smarty_modifier_thousand($num, $delim="'", $divs='', $pnum=1) {
	if (!$num)
		return 0;

	if ($divs == 'k')
		$div = 1024;
	else if ($divs == 'm')
		$div = 1048576;
	else if ($divs == 'g')
		$div = 1073741824;

	if ($div)
		$num = sprintf('%.'.$pnum.'f', ($num/$div));

	$num = strval($num);
	if (($num != 0) && $divs)
		$num .= $divs;
	$p = strrpos($num, '.');
	if ($p === false)
		$p = strlen($num);
	for ($i=1, --$p; $p > 0; --$p, ++$i) {
		if (!($i % 3)) {
			$num = substr($num, 0, $p) . $delim . substr($num, $p);
		}
	}
	return $num;
}

$smarty->register_modifier('thousand', 'smarty_modifier_thousand');
/*
 *Smarty plugin
 *--------------------------------------------------------------
 * Author: 		Xoxol
 * Type:		modifier
 * Purpose: 	     
 * Arguments:
 *				-,
 *				- 
 *				{{'&nbsp;'|copier:3}} ->&nbsp;&nbsp;&nbsp; 
 */
function smarty_modifier_copier($str, $num=1) {
	for($i=0;$i<$num;++$i) 
		$newstr.=$str;
	return $newstr;
}
$smarty->register_modifier('copier', 'smarty_modifier_copier');

function remove_html_comments($tpl_source, &$smarty) {
	return preg_replace("/<!--.*-->/U","",$tpl_source);
}

//   ".locations.inc.php"   -   .    
if ($prefilters) { 
	$smarty->register_prefilter("remove_html_comments");
}
?>
