<?php

require_once('../.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'HTML/QuickForm.php');
require_once($lpath['common'].'HTML/QuickForm/Renderer/ArraySmarty.php');
require_once($lpath['common'].'session.php');

/*
if (!$is_admin) {
    header("Location: http://".$lpath['url']."/index.php?SID=$SID");
    exit;
};
 */
/* moved to .locations.inc.php
$image_path = $lpath['www'].'pictures/';
$product_image_dir = 'prod/';
$location_image_dir= 'loc/';
 */

/*
// check action param
if (isset($_POST['action']) or isset($_GET['action']))  {
    if (isset($_POST['action']))  {
        $action=$_POST['action'];
    } elseif (isset($_GET['action'])) {
        $action=$_GET['action'];
    };
}
 */

// use id to fill form for edit
if (isset($_POST['id']) or isset($_GET['id'])) {
    if (isset($_POST['id']))
        $obj_id = (int) $_POST['id'];
    elseif (isset($_GET['id']))
        $obj_id = (int) $_GET['id'];
};

return_variable_from_request('action');
return_variable_from_request('addNewProp');

switch ($action) {
case 'edit_product':

    $title = "edit product";

    $form = new HTML_QuickForm('frmAddProduct', 'post', 'edit.php');

    // adding basic form elements
    $info[] = $form->createElement('text', 'prodName', 'name:');
    $info[] = $form->createElement('textarea', 'prodDescr', 'description:');
    $info[] = $form->createElement('text', 'prodPrice', 'price:');
    $info[] = $form->createElement('checkbox', 'prodTop', 'special offer:');

    $list_product_category = array();
    $r = get_obj_list("product_category", array(0 => array('visible' =>0, 'field_name' => 'id'),1 => array('visible' =>1, 'field_name' => 'name')));
    foreach ($r as $row)
        $list_product_category[$row['id']] = $row['name'];

    $list_locations = array();
    $r = get_obj_list("locations", array(0 => array('visible' =>0, 'field_name' => 'id'),1 => array('visible' =>1, 'field_name' => 'name')));
    foreach ($r as $row)
        $list_locations[$row['id']] = $row['name'];

    $list_products = array();
    $list_products[] = False;
    $r = get_obj_list('product', array(0 => array('field_name' => 'id'), 1 => array('field_name' => 'name')));
    foreach ($r as $row)
        if ($row['id'] != $obj_id) // do not include self in list
            $list_products[$row['id']] = $row['name'];

    //$info[] = $form->createElement('select', 'prodCat', 'category:', $list_product_category);
    $info[] = $form->createElement('select', 'prodLoc', 'location:', $list_locations);
    $info[] = $form->createElement('select', 'prodRel', 'related products:', $list_products, 'multiple');

    $form->addGroup($info, 'prodInfo', 'product info', null, false);

    $form->addElement('hidden', 'action', $action);
    $form->addElement('hidden', 'id', $obj_id);

    if ($obj_id) {
        $product_properties = get_property_values_for_product($obj_id);
        $r = get_obj_list('product_related', 
            array(
                0 => array('visible' => 1, 'field_name' => 'related_id'),
                1 => array('visible' => 1, 'field_name' => 'product_id')
            ),
            array(0 => array('visible' => 1, 'field_name' => 'product_id', "value" => $obj_id)) );
        foreach ($r as $row)
            $related_products[] = $row['related_id'];
        $product_info = get_product_by_id($obj_id);
        $form->setDefaults(array(
            'prodName'=>$product_info['name'],
            'prodDescr'=>$product_info['description'],
            'prodPrice'=>$product_info['price'],
            'prodLoc'=>$product_info['location_id'],
            'prodTop' => $product_info['isSpecOffer'],
            'prodRel' => $related_products
        ));
    }


    $list_property = array();
    $list_property[0] = 'none';
    $r = get_obj_list("property", array(0 => array('visible' =>0, 'field_name' => 'id'),1 => array('visible' =>1, 'field_name' => 'name')));
    foreach ($r as $row)
        $list_property[$row['id']] = $row['name'];


        if ($product_properties) {
          foreach($product_properties as $item) {
            $prop_tmp = $form->createElement('select', 'prodProp'.$item['property_value_id'], 'property:', $list_property);
            $prop_tmp->setSelected($item['property_id']);
            $prop[] = $prop_tmp;
            $prop_tmp = $form->createElement('text', 'prodPropVal'.$item['property_value_id'], null);
            $prop_tmp->setValue($item['property_value']);
            $prop[] = $prop_tmp;
            //$prop[] = $form->createElement('link', 'delete'.$item['property_value_id'], null, 'edit.php?action=del_property_value&id='.$item['property_value_id'], 'x', 'class="delete"');
          }
        }
        // add new empty property elements
        $prop[] = $form->addElement('text', 'addNewProp', 'add new properties (amount):');
        /*
        else {
            for($i=0;$i<4;$i++) {
                $prop[] = $form->createElement('select', 'prodProp'.$i, 'property:', $list_property);
                $prop[] = $form->createElement('text', 'prodPropVal'.$i, null);
            }
        }
         */

        $form->addGroup($prop, 'prodProp', 'product properties', null, false);

    if(!$form->isSubmitted()) {
        $form->addElement('submit', 'btnSubmit', 'Send', 'class="button"');
    }

    if ($form->isSubmitted() && $form->validate()) {
        $form->addElement('link', 'edit_product_'.$obj_id, null, "edit.php?action=edit_product&id=$obj_id", 'Edit this product again');
        $form->freeze();
        $res = product_update($form->exportValues());
        // set related products
        $prod_info = $form->getElementValue('prodInfo');
        $prod_related = $prod_info['prodRel'];
        if (is_array($prod_related) && $prod_related > 0)
            set_related_for_product($obj_id, $prod_related);

        if (is_int($res)) {
            $smarty->assign('message', 'product saved!');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    }

    display_renderer_form($form, "edit");

    break;

case 'edit_product_category':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "product_category";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'catName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'catDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_property':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "property";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'propName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'propDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_locations':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "locations";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'locName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'locDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_news':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "news";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'newsTitle', 'caption' => 'Title:', 'field_name' => 'title'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'newsShortBody', 'caption' => 'Short body:', 'field_name' => 'short_body'),
                 2 => array('visible' =>1,'type' => 'textarea', 'name' => 'newsBody', 'caption' => 'Body:', 'field_name' => 'body'),
                 3 => array('visible' =>1, 'type' => 'text', 'name' => 'source', 'caption' => 'Source website:', 'field_name' => 'source'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_account':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "account";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'userName', 'caption' => 'Username:', 'field_name' => 'username'),
                 1 => array('visible' =>1, 'type' => 'text', 'name' => 'password', 'caption' => 'Password:', 'field_name' => 'password'),
                 2 => array('visible' =>1, 'type' => 'text', 'name' => 'firstName', 'caption' => 'Firstname:', 'field_name' => 'firstname'),
                 3 => array('visible' =>1, 'type' => 'text', 'name' => 'secName', 'caption' => 'Secondname:', 'field_name' => 'secondname'),
                 4 => array('visible' =>1, 'type' => 'text', 'name' => 'email', 'caption' => 'E-mail:', 'field_name' => 'email'),
                 5 => array('visible' =>1, 'type' => 'text', 'name' => 'phone', 'caption' => 'Phone:', 'field_name' => 'phone'),
                 6 => array('visible' =>1, 'type' => 'checkbox', 'name' => 'admin', 'caption' => 'Admin:', 'field_name' => 'admin'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_product':

    $title = "add product";

    $form = new HTML_QuickForm('frmAddProduct', 'post', 'edit.php');

    $list_product_category = array();
    $r = get_obj_list("product_category", array(0 => array("field_name" => "id"),1 => array("field_name" => "name")));
    foreach ($r as $row) {
        $list_product_category[$row['id']] = $row['name'];
    }

    $list_locations = array();
    $r = get_obj_list("locations", array(0 => array("field_name" => "id"),1 => array("field_name" => "name")));
    foreach ($r as $row) {
        $list_locations[$row['id']] = $row['name'];
    }

    $list_products = array();
    $list_products[] = Null;
    $r = get_obj_list('product', array(0 => array('field_name' => 'id'), 1 => array('field_name' => 'name')));
    foreach ($r as $row)
        $list_products[$row['id']] = $row['name'];


    // adding basic form elements
    $info[] = $form->createElement('text', 'prodName', 'name:');
    $info[] = $form->createElement('textarea', 'prodDescr', 'description:');
    $info[] = $form->createElement('text', 'prodPrice', 'price:');
    $info[] = $form->createElement('checkbox', 'prodTop', 'special offer:');
    $info[] = $form->createElement('select', 'prodLoc', 'location:', $list_locations);
    $info[] = $form->createElement('select', 'prodRel', 'related products:', $list_products, 'multiple');

    $form->addGroup($info, 'prodInfo', 'product info', null, false);

    $form->addElement('hidden', 'action', $action);

    $form->addRule('prodName', 'product name is required', 'required');
    $form->addRule('prodDescr', 'product description is required', 'required');
    $form->addRule('prodPrice', 'product price is required', 'required');
    $form->addRule('prodPrice', 'product price must be numeric value', 'numeric');
    $form->addRule('prodLoc', 'product location is required', 'required');

    $list_property = array();
    $list_property[0] = 'none';
    $r = get_obj_list("property", array(0 => array("field_name" => "id"),1 => array("field_name" => "name")));
    foreach ($r as $row) {
        $list_property[$row['id']] = $row['name'];
    }

    $tmp_prop = null;
    foreach ($list_property as $i => $property) {
        if ($i == 0)
            continue;
        $tmp_prop = $form->createElement('select', 'prodProp'.$i, 'property:', $list_property);
        $tmp_prop->setValue($i);
        $prop[] = $tmp_prop;
        $prop[] = $form->createElement('text', 'prodPropVal'.$i, null);
    }

    $form->addGroup($prop, 'prodProp', 'product properties', null, false);

    if ($obj_id)
        $my_product = get_product_by_id($obj_id);
        $form->setDefaults(array(
            'prodName'=>$my_product['name'],
            'prodDescr'=>$my_product['description'],
            'prodPrice'=>$my_product['price'],
            'prodLoc'=>$my_product['location_id']
        ));

    if(!$form->isSubmitted()) {
        $form->addElement('submit', 'btnSubmit', 'Send', 'class="button"');
    }

    if ($form->isSubmitted() && $form->validate()) {
        $form->freeze();
        $res = product_insert($form->exportValues());
        // set related products
        $prod_info = $form->getElementValue('prodInfo');
        $prod_related = $prod_info['prodRel'];
        if (is_array($prod_related) && $prod_related > 0)
            set_related_for_product($res, $prod_related);

        if (is_int($res)) {
            $smarty->assign('message', 'product saved!');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    }

    display_renderer_form($form, "edit");

    break;

case 'add_product_category':

    $table = "product_category";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'catName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'catDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_meta':
    $table = 'pages_meta';
    $field_arr = array(
        0 => array('visible' => 1, 'type' => 'text', 'name' => 'title', 'caption' => 'Title:', 'field_name' => 'title'),
        1 => array('visible' => 1, 'type' => 'text', 'name' => 'keywords', 'caption' => 'Keywords:', 'field_name' => 'keywords'),
        2 => array('visible' => 1, 'type' => 'textarea', 'name' => 'description', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
        0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);
    break;
case 'add_property':

    $table = "property";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'propName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'propDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_locations':

    $table = "locations";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'locName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' =>1,'type' => 'textarea', 'name' => 'locDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_news':

    $table = "news";

    $field_arr = array(
                 0 => array('visible' => 1, 'type' => 'text', 'name' => 'newsTitle', 'caption' => 'Title:', 'field_name' => 'title'),
                 1 => array('visible' => 1, 'type' => 'textarea', 'name' => 'newsShortBody', 'caption' => 'Short body:', 'field_name' => 'short_body'),
                 2 => array('visible' => 1, 'type' => 'textarea', 'name' => 'newsBody', 'caption' => 'Body:', 'field_name' => 'body'),
                 3 => array('visible' => -1, 'type' => '', 'name' => 'newsDate', 'caption' => 'NOW()', 'field_name' => 'date'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_account':

    $table = "account";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'userName', 'caption' => 'Username:', 'field_name' => 'username'),
                 1 => array('visible' =>1, 'type' => 'text', 'name' => 'password', 'caption' => 'Password:', 'field_name' => 'password'),
                 2 => array('visible' =>1, 'type' => 'text', 'name' => 'firstName', 'caption' => 'Firstname:', 'field_name' => 'firstname'),
                 3 => array('visible' =>1, 'type' => 'text', 'name' => 'secName', 'caption' => 'Secondname:', 'field_name' => 'secondname'),
                 4 => array('visible' =>1, 'type' => 'text', 'name' => 'email', 'caption' => 'E-mail:', 'field_name' => 'email'),
                 5 => array('visible' =>1, 'type' => 'text', 'name' => 'phone', 'caption' => 'Phone:', 'field_name' => 'phone'),
                 6 => array('visible' =>1, 'type' => 'checkbox', 'name' => 'admin', 'caption' => 'Admin:', 'field_name' => 'admin'),
                 7 => array('visible' =>-1, 'type' => '', 'name' => 'lastVisit', 'caption' => 'NOW()', 'field_name' => 'last_visit'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_product':

    $title = "delete product";

    $form = new HTML_QuickForm('frmDelProduct', 'post', 'edit.php');

    if ($form->isSubmitted() && $form->validate()) {
        $res = product_delete($obj_id);
        if (!$res) {
            $smarty->assign('message', 'product deleted!');

            unset($form);
            $form = new HTML_QuickForm('frmListProduct', 'get', 'list.php');
            $form->addElement('hidden', 'action', 'get_list_product');
            $form->addElement('submit', 'btnSubmit', 'OK', 'class="button"');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        $smarty->assign('message', $title." ".$_GET['product_name'].' ?');

        // adding basic form elements
        $form->addElement('hidden', 'action', $action);
        $form->addElement('hidden', 'id', $obj_id);

        $form->addElement('submit', 'btnSubmit', 'Delete', 'class="button"');
    }

    display_renderer_form($form, "edit");

    break;

case 'del_product_category':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "product_category";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'catName', 'caption' => 'Name:', 'field_name' => 'name'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_property':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "property";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'propName', 'caption' => 'Name:', 'field_name' => 'name'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_property_value':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "property_value";

    $field_arr = null;
    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;

case 'del_locations':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "locations";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'locName', 'caption' => 'Name:', 'field_name' => 'name'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_news':

    if (!isset($obj_id)) { header("Location: ".$lpath['url']); exit; }

    $table = "news";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'newsTitle', 'caption' => 'Title:', 'field_name' => 'title'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_account':

    if (!isset($obj_id)) { header("Location: ".$lpath['url']); exit; }

    $table = "account";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'text', 'name' => 'userName', 'caption' => 'Username:', 'field_name' => 'username'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_state':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "state";

    $field_arr = array(
                 0 => array('visible' => 1, 'type' => 'checkbox', 'name' => 'stateMilestone', 'caption' => 'Milestone:', 'field_name' => 'milestone'),
                 1 => array('visible' => 1, 'type' => 'textarea', 'name' => 'stateDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'add_state':

    // use product_id to fill form for edit
    if (isset($_POST['product_id']) or isset($_GET['product_id'])) {
        if (isset($_POST['product_id']))
            $prod_id = (int) $_POST['product_id'];
        elseif (isset($_GET['product_id']))
            $prod_id = (int) $_GET['product_id'];
    } else { header("Location: http://".$lpath['url']); exit; }

    $field_arr = array();
    if (!get_obj_by_id("product", $field_arr, $prod_id)) {
        header("Location: http://".$lpath['url']); exit;
    }

    $table = "state";

    $field_arr = array(
                 0 => array('visible' => 1, 'type' => 'checkbox', 'name' => 'stateMilestone', 'caption' => 'Milestone:', 'field_name' => 'milestone'),
                 1 => array('visible' => 1, 'type' => 'textarea', 'name' => 'stateDescr', 'caption' => 'Description:', 'field_name' => 'description'),
                 2 => array('visible' => 0, 'type' => '', 'name' => 'stateProd', 'caption' => $prod_id, 'field_name' => 'product'),
                 3 => array('visible' => -1, 'type' => '', 'name' => 'stateDate', 'caption' => 'NOW()', 'field_name' => 'pub_date'));


    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'product_id', 'value' => $prod_id));

    edit_obj("add", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'del_state':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "state";

    $field_arr = array(
                 0 => array('visible' =>1, 'type' => 'textarea', 'name' => 'stateDescr', 'caption' => 'Description:', 'field_name' => 'description'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
case 'edit_picture':
    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }
    
    $title = 'add image';
    $table = "picture";

    $form = new HTML_QuickForm('frmEditImage', 'post', 'edit.php');

    $form->addElement('hidden', 'action', $action);
    $form->addElement('hidden', 'id', $obj_id);

    $alt_text = $form->addElement('text', 'imageName', 'alt text:');
    $main_image = $form->addElement('checkbox', 'imgMain', 'main product image:');

    $form->addGroup(array($alt_text, $main_image), 'prodInfo', 'photo meta info', null, false);

    $img_field = $form->addElement('file', 'prodPhotoFile', 'photo file:', 'class="file"');
    /*
    $img_fields[0] = $form->addElement('file', 'prodPhotoThumb', 'thumbnail:', 'class="file"');
    $img_fields[1] = $form->addElement('file', 'prodPhotoMidThumb', 'thumbnail for product list:', 'class="file"');
    $img_fields[2] = $form->addElement('file', 'prodPhotoMid', 'normal image:', 'class="file"');
    $img_fields[3] = $form->addElement('file', 'prodPhotoBig', 'fulsize image:', 'class="file"');
    $img_fields[4] = $form->addElement('file', 'prodPhotoSpec', 'special offer image:', 'class="file"');
     */
    $form->addGroup(array($img_field), 'prodPhoto', 'product photo', null, false);

    $field_arr = array(
        0 => array('name' => 'imageName', 'field_name' => 'picture.name AS name'),
        1 => array('name' => 'imgMain', 'field_name' => 'picture.is_main AS is_main', ),
    );

    $image_info = get_obj_by_id($table, $field_arr, $obj_id);
        $form->setDefaults(array(
            'imageName'=>$image_info[0]['name'],
            'imgMain'=>$image_info[0]['is_main'],
        ));


    if(!$form->isSubmitted()) {
        $form->addElement('submit', 'btnSubmit', 'Send', 'class="button"');
    }

    if ($form->isSubmitted() && $form->validate()) {
        $form->freeze();

        $field_arr = array(
            0 => array('visible' => 1, 'name' => 'imageName', 'caption' => 'Alt text', 'field_name' => 'name'),
            1 => array('visible' => 1, 'name' => 'imgMain', 'caption' => 'main product image', 'field_name' => 'is_main'),
        );
        $data = array(
            'id' => $obj_id,
            'imageName' => $alt_text->getValue(),
            'imgMain' => $main_image->getValue(),
        );

        $res = obj_update($table, $field_arr, $data);

        /*
        if ($img_fields[0]->isUploadedFile())
            $res_0 = $img_fields[0]->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'_thumb.jpg');
        if ($img_fields[1]->isUploadedFile())
            $res_1 = $img_fields[1]->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'_prod_thumb.jpg');
        if ($img_fields[2]->isUploadedFile())
            $res_2 = $img_fields[2]->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'_big.jpg');
        if ($img_fields[3]->isUploadedFile())
            $res_3 = $img_fields[3]->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'.jpg');
        if ($img_fields[4]->isUploadedFile())
            $res_4 = $img_fields[4]->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'_spec.jpg');
         */

        if ($img_field->isUploadedFile())
            $copy_res = $img_field->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'.jpg');
        if ($copy_res) {
            resize_img(110, 82,  $image_path.$product_image_dir.'pic'.$res, '_thumb');
            resize_img(150, 140, $image_path.$product_image_dir.'pic'.$res, '_prod_thumb');
            resize_img(314, 266, $image_path.$product_image_dir.'pic'.$res, '_big');
            resize_img(131, 140, $image_path.$product_image_dir.'pic'.$res, '_spec');
        }



        if (is_int($res)) {
            $smarty->assign('message', 'image saved!');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    }

    display_renderer_form($form, "edit");


    break;
/*
case 'edit_picture':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "picture";

    $field_arr = array(
                 0 => array('visible' => 1, 'type' => 'text', 'name' => 'pictName', 'caption' => 'Name:', 'field_name' => 'name'),
                 1 => array('visible' => 1, 'type' => 'file', 'name' => 'pictFile', 'caption' => 'File:', 'field_name' => 'path'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    $res = edit_obj("edit", $obj_id, $table, $field_arr, $hidden_arr);
        if ($res) {
            // generate thumbnail
            resize_img(106, 78, $image_path.$product_image_dir.substr($table, 0, 3).$res, '_thumb');
            // generate product image
            resize_img(314, 266, $image_path.$product_image_dir.substr($table, 0, 3).$res, '_big');
        }

    break;
*/
case 'add_picture':
    $title = 'add image';

    if (isset($_POST['product_id']) or isset($_GET['product_id'])) {
        if (isset($_POST['product_id']))
            $prod_id = (int) $_POST['product_id'];
        elseif (isset($_GET['product_id']))
            $prod_id = (int) $_GET['product_id'];
    } else { header("Location: http://".$lpath['url']); exit; }

    $field_arr = array();
    if (!get_obj_by_id("product", $field_arr, $prod_id)) {
        header("Location: http://".$lpath['url']); exit;
    }

    $form = new HTML_QuickForm('frmAddImage', 'post', 'edit.php');

    $form->addElement('hidden', 'action', $action);
    $form->addElement('hidden', 'product_id', $prod_id);

    $alt_text = $form->addElement('text', 'imageName', 'alt text:');
    $main_image = $form->addElement('checkbox', 'imgMain', 'main product image:');

    $form->addGroup(array($alt_text, $main_image), 'prodInfo', 'photo meta info', null, false);

    $img_field = $form->addElement('file', 'prodPhotoFile', 'photo file:', 'class="file"');
    //$img_fields[1] = $form->addElement('file', 'prodPhotoMidThumb', 'thumbnail for product list:', 'class="file"');
    //$img_fields[2] = $form->addElement('file', 'prodPhotoMid', 'normal image:', 'class="file"');
    //$img_fields[3] = $form->addElement('file', 'prodPhotoBig', 'fulsize image:', 'class="file"');
    //$img_fields[4] = $form->addElement('file', 'prodPhotoSpec', 'special offer image:', 'class="file"');

    $form->addGroup(array($img_field), 'prodPhoto', 'product photo', null, false);

    if(!$form->isSubmitted()) {
        $form->addElement('submit', 'btnSubmit', 'Send', 'class="button"');
    }

    if ($form->isSubmitted() && $form->validate()) {
        $form->freeze();

        $table = "picture";
        $field_arr = array(
            0 => array('visible' => 1, 'name' => 'imageName', 'caption' => 'Alt text', 'field_name' => 'name'),
            1 => array('visible' => 1, 'name' => 'product_id', 'caption' => '', 'field_name' => 'product'),
            2 => array('visible' => 1, 'name' => 'imgMain', 'caption' => 'main product image', 'field_name' => 'is_main'),
        );
        $data = array(
            'imageName' => $alt_text->getValue(),
            'product_id' => $prod_id,
            'imgMain' => $main_image->getValue(),
        );

        $res = obj_insert($table, $field_arr, $data);


        if ($img_field->isUploadedFile())
            $copy_res = $img_field->moveUploadedFile($image_path.$product_image_dir, 'pic'.$res.'.jpg');
        if ($copy_res) {
            resize_img(110, 82,  $image_path.$product_image_dir.'pic'.$res, '_thumb');
            resize_img(150, 140, $image_path.$product_image_dir.'pic'.$res, '_prod_thumb');
            resize_img(314, 266, $image_path.$product_image_dir.'pic'.$res, '_big');
            resize_img(131, 140, $image_path.$product_image_dir.'pic'.$res, '_spec');
        }

        if (is_int($res) and $copy_res) {
            $smarty->assign('message', 'image saved!');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    }

    display_renderer_form($form, "edit");

    break;

case 'del_picture':

    if (!isset($obj_id)) { header("Location: http://".$lpath['url']); exit; }

    $table = "picture";

    $field_arr = array(
                 0 => array('visible' => 1, 'type' => 'text', 'name' => 'pictName', 'caption' => 'Name:', 'field_name' => 'name'));

    $hidden_arr = array(
                 0 => array('name' => 'action', 'value' => $action),
                 1 => array('name' => 'id', 'value' => $obj_id));

    edit_obj("delete", $obj_id, $table, $field_arr, $hidden_arr);

    break;
default:
    die("Don't use this function!!!");
    break;
};

?>
