<?php

require_once('../.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'session.php');

/*
if (!$is_admin) {
    header("Location: http://".$lpath['url']."/index.php?SID=$SID");
    exit;
};
 */

// check action param
if (isset($_POST['action']) or isset($_GET['action']))  {
    if (isset($_POST['action']))  {
        $action=$_POST['action'];
    } elseif (isset($_GET['action'])) {
        $action=$_GET['action'];
    };
} else {
    $action='get_list_product';
}

switch ($action) {
case 'get_list_news':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'title AS name'));
    $order_by_arr = array(
                 0 => array("field_name" => "date", "value" => "DESC"));
    list_obj("news", $field_arr, array (), array (), $order_by_arr);
    break;
case 'get_list_product_category':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'name'));
    list_obj("product_category", $field_arr);
    break;
case 'get_list_locations':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'name'));
    list_obj("locations", $field_arr);
    break;
case 'get_list_property':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'name'));
    list_obj("property", $field_arr);
    break;
case 'get_list_product':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'name'));
    $item_arr = array(
                 0 => array('table' => "state"),
                 1 => array('table' => "picture"));
    list_obj("product", $field_arr, $item_arr);
    break;
case 'get_list_picture':
    return_variable_from_request('product_id');
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'name'),
                 2 => array('field_name' => 'is_main'),
             );
    $where_arr = array(
                 0 => array("field_name" => "product", "value" => "'".$product_id."'"));
    list_obj("picture", $field_arr, null, $where_arr, null, $product_id, 'product');
    break;
case 'get_list_state':
    // use product_id to fill form for edit
    return_variable_from_request('product_id');

    $field_arr = array();
    if (!get_obj_by_id("product", $field_arr, $product_id)) {
        header("Location: ".$lpath['url']); exit;
    }

    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => "CONCAT(DATE_FORMAT(state.pub_date, '%d.%m.%Y'), ' - ', RIGHT(state.description,20), '...') AS name"));
    $item_arr = array();
    $where_arr = array(
                 0 => array("field_name" => "product", "value" => "'".$product_id."'"));
    list_obj("state", $field_arr, $item_arr, $where_arr, null, $product_id, 'product');
    break;
case 'get_list_account':
    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'username AS name'));
    list_obj("account", $field_arr);
    break;
case 'get_list_meta':
    $field_arr = array(
        0 => array('field_name' => 'slug'),
        1 => array('field_name' => 'id'),
        2 => array('field_name' => 'title AS name'));
    list_obj('pages_meta', $field_arr);
    break;
default:
    die("Don't use this function!!!");
    break;
};


?>
