<?php
require_once('../.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');


$err_message = array();

return_variable_from_request('subject');
return_variable_from_request('messageText');
return_variable_from_request('properties');

if ($subject || $messageText || $properties) {
        if (empty($subject))
            $err_message [] = 'required message subject';
        if (empty($messageText))
            $err_message [] = 'required message text';
        if (empty($properties))
            $err_message [] = 'required property select';
        $smarty->assign('err_message', $err_message);
}


/*
if (!return_variable_from_request('subject'))
    $err_message [] = 'required message subject';

if (!return_variable_from_request('messageText'))
    $err_message [] = 'required message text';

if (!return_variable_from_request('properties'))
    $err_message [] = 'required property select';

// show errors about required fields
$smarty->assign('err_message', $err_message);
 */

$properties = (int) $properties;

$products = get_obj_list("product", array(
    0 => array('visible' =>0, 'field_name' => 'id'),
    1 => array('visible' =>1, 'field_name' => 'name')
));

foreach ($products as $prod)
    $attach_properties[$prod['id']] = $prod['name'];
// fill select box
$smarty->assign('attach_properties', $attach_properties);

if ($subject && $messageText && $properties) {
    $field_arr = array (
        0 => array("field_name" => "product.name AS name"),
        1 => array("field_name" => "locations.name AS location"),
        2 => array("field_name" => "product.id AS id")
    );
    $where_arr = array(
        0 => array("field_name" => "product.id", "value" => $properties),
    );
    $my_product = get_obj_list('product, locations', $field_arr, $where_arr, null, 1);
    $my_product = $my_product[0];
    $message = $messageText;
    $message .= "\n\n".
                "Attached property - ".$my_product['name']."(".$my_product['location'].")".
                "You can see full description and feedback from ".$lpath['host']."/main.php?action=get_prod&prod_id=".$my_product['id'];

    $field_arr = array (
        0 => array("field_name" => "account.username AS username"),
        1 => array("field_name" => "account.firstname AS firstname"),
        2 => array("field_name" => "account.secondname AS secondname"),
        3 => array("field_name" => "account.email AS email"),
        4 => array("field_name" => "product.name AS product"),
        5 => array("field_name" => "product.id AS product_id")
    );

    $where_arr = array(
        0 => array("field_name" => "account.id", "value" => "account_to_product.account"),
        1 => array("field_name" => "account_to_product.product", "value" => "product.id"),
        2 => array("field_name" => "product.id", "value" => $properties),
    );

    $mail_users = get_obj_list('account, product, account_to_product', $field_arr, $where_arr);

    $status = array();

    if ($mail_users) {
        foreach ($mail_users as $m_user) {
            $mail_sent = mail($m_user['email'], $subject, $messageText);
            if ($mail_sent)
                $status[] = array('email' => $m_user['email'], 'done' => 'ok');
            else
                $status[] = array('email' => $m_user['email'], 'done' => 'error');
        }
    }
    else
        $status[] = 'no users to send';

    $smarty->assign('message_status', $status);

}

$smarty->assign('subject', $subject);
$smarty->assign('messageText', $messageText);
$smarty->assign('properties', $properties);

$smarty->assign('title', 'send message');
$smarty->display('admin/message.html');


?>
