<?

require_once('.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'session.php');
require_once($lpath['common'].'HTML/QuickForm.php');
require_once($lpath['common'].'HTML/QuickForm/Renderer/ArraySmarty.php');

$is_forgpswd_form = false;

// check action param
return_variable_from_request('action','');

switch ($action) {
case 'auth':
    $error_auth = false;

    if (!return_variable_from_request('username'))
        $error_auth = "Username required!";

    if (!return_variable_from_request('password'))
        $error_auth = "Password required!";

    $field_arr = array(
                 0 => array('field_name' => 'id'),
                 1 => array('field_name' => 'username'),
                 2 => array('field_name' => 'firstname'),
                 3 => array('field_name' => 'secondname'),
                 4 => array('field_name' => 'email'),
                 5 => array('field_name' => 'phone'),
                 6 => array('field_name' => 'last_visit'),
                 7 => array('field_name' => 'admin'));

    $where_arr = array(
                 0 => array("field_name" => "username", "value" => "'".$username."'"),
                 1 => array("field_name" => "password", "value" => "'".$password."'"));
    $account_info = get_obj_list('account', $field_arr, $where_arr, NULL, 1);
    $account_info = $account_info[0];

    if (!$account_info) {
        $error_auth = "Username or Password wrong!";
        $_SESSION['is_logged'] = 0;
    } else {
        $_SESSION['id'] = $account_info['id'];
        $_SESSION['username'] = $account_info['username'];
        $_SESSION['firstname'] = $account_info['firstname'];
        $_SESSION['secondname'] = $account_info['secondname'];
        $_SESSION['email'] = $account_info['email'];
        $_SESSION['phone'] = $account_info['phone'];
        $_SESSION['last_visit'] = $account_info['last_visit'];
        $_SESSION['admin'] = $account_info['admin'];
        $_SESSION['is_logged'] = 1;
    };

    $is_log = $_SESSION['is_logged'];

    if ($is_log) {
        header("Location: /main.php?action=get_list_product&user_id=".$account_info['id']);
    } else {
        // include for standart blocks (news/locations)
        require_once($lpath['include'].'standart_blocks.php');
        $smarty->assign('account_info', $account_info);
        $smarty->assign('error', $error_auth);
        $smarty->assign('auth', $_SESSION['is_logged']);
        $smarty->assign('is_forgpswd_form', $is_forgpswd_form);
        $smarty->display('auth.html');
    };

    break;
case 'logout':
    if ($is_log) {
        if (session_is_registered('id'))
            session_unregister('id');
        if (session_is_registered('username'))
            session_unregister('username');
        if (session_is_registered('firstname'))
            session_unregister('firstname');
        if (session_is_registered('secondname'))
            session_unregister('secondname');
        if (session_is_registered('email'))
            session_unregister('email');
        if (session_is_registered('phone'))
            session_unregister('phone');
        if (session_is_registered('last_visit'))
            session_unregister('last_visit');
        $_SESSION['is_logged'] = 0;
        $_SESSION['admin'] = 0;
        $is_log = 0;
        $is_admin = 0;
    };

    header("Location: http://".$lpath['url']."/main.php?SID=$SID");

    break;
case 'forgpswd':
    $error_forgpswd = false;

    return_variable_from_request('lev','get');

    if ($lev == 'set') {
        if (!return_variable_from_request('username'))
            $error_forgpswd = "Username required!";

        $field_arr = array(
                     0 => array('field_name' => 'account.id AS id'),
                     1 => array('field_name' => 'question_answer.question AS question'));
        $where_arr = array(
                     0 => array("field_name" => "account.username", "value" => "'".$username."'"),
                     1 => array("field_name" => "question_answer.account", "value" => "account.id"));

        $list = get_obj_list('account, question_answer', $field_arr, $where_arr, NULL, 1);
        if (is_array($list))
            $list = $list[0];

        $field_arr = array(
                     0 => array('field_name' => 'account.id AS id'),
                     1 => array('field_name' => 'account.username AS username'),
                     2 => array('field_name' => 'account.password AS password'),
                     3 => array('field_name' => 'account.email AS email'));
        if (!$list) {
            $table = 'account';
            $where_arr = array(
                     0 => array("field_name" => "account.username", "value" => "'".$username."'"));
        } else {
            $table = 'account, question_answer';
            $where_arr = array(
                     0 => array("field_name" => "account.username", "value" => "'".$username."'"),
                     1 => array("field_name" => "question_answer.answer", "value" => "'".$secretA."'"),
                     2 => array("field_name" => "question_answer.account", "value" => "account.id"));
        };

        $account_info = get_obj_list($table, $field_arr, $where_arr, NULL, 1);
        if (is_array($account_info))
            $account_info = $account_info[0];

        if (!$account_info) {
            if (!$list) {
                $error_forgpswd="Username or Secret answer wrong!";
            } else {
                $smarty->assign('question', $list['question']);
            };
            $is_forgpswd_form = true;
        } else {
            $error_forgpswd="Message with your password succefully sended to your mail!";
            //mail...
            //output result request...
            $subject = "www.exoticpropertysale.com - Password reminder";
            $message = "You requested password recovery at http://exoticpropertysales.com. \n";
            $message .= "Your username is <".$account_info['username']."> and your password is <".$account_info['password']."> ";
            mail($account_info['email'], $subject, $message);

            $is_forgpswd_form = true;
        };
    } elseif ($lev='get') {
        $is_forgpswd_form = true;
    };

    // include for standart blocks (news/locations)
    require_once($lpath['include'].'standart_blocks.php');
    //$smarty->assign('account_info', $account_info);
    $smarty->assign('username', $username);
    $smarty->assign('error', $error_forgpswd);
    //$smarty->assign('auth', false);
    $smarty->assign('is_forgpswd_form', $is_forgpswd_form);
    $smarty->display('auth.html');
    break;
case 'register':

    $error_reg = false;
    $reg = false;

    if ((!return_variable_from_request('username')) or ($username == ''))
    $error_reg = "Required field 'Username'!";

    $field_arr = array(
                 0 => array('field_name' => 'id'));
    $where_arr = array(
                 0 => array("field_name" => "username", "value" => "'".$username."'"));
    $list = get_obj_list('account', $field_arr, $where_arr);
    if ((is_array($list)) and (count($list) != 0))
        $error_reg .= "Username '".$username."' already exists! ";

    if ((!return_variable_from_request('password','')) or ($password == ''))
        $error_reg .= "Required field 'Create password'! ";

    if ((!return_variable_from_request('password2','')) or ($password2 == ''))
        $error_reg .= "Required field 'Confirm password'! ";

    if ($password2 != $password)
        $error_reg .= "Fields 'Create password' and 'Confirm password' not equal! ";

    if ((!return_variable_from_request('email','')) or ($email == ''))
        $error_reg .= "Required field 'E-mail'! ";

    if (!eregi("^[a-z0-9\._-]+@[a-z0-9\._-]+\.[a-z]{2,4}\$", $email))
        $error_reg .= "Field 'E-mail' is invalid! ";

    //if ((!return_variable_from_request('secretQ','')) or (strlen($secretQ) <= 3))
    //    $error_reg .= "Required field 'Secret question'! ";

    //if ((!return_variable_from_request('secretA','')) or (strlen($secretA) <= 3))
    //    $error_reg .= "Required field 'Secret answer'! ";

    if (!$error_reg) {
        return_variable_from_request('firstname','no');
        return_variable_from_request('secondname','no');
        return_variable_from_request('phone','no');
        return_variable_from_request('secretQ','');
        return_variable_from_request('secretA','');

        $field_arr = array(
                     0 => array('visible' =>1, 'name' => 'username', 'caption' => 'Username', 'field_name' => 'username'),
                     1 => array('visible' =>1, 'name' => 'password', 'caption' => 'Create password', 'field_name' => 'password'),
                     2 => array('visible' =>1, 'name' => 'email', 'caption' => 'Email', 'field_name' => 'email'),
                     3 => array('visible' =>1, 'name' => 'firstname', 'caption' => 'Firstname', 'field_name' => 'firstname'),
                     4 => array('visible' =>1, 'name' => 'secondname', 'caption' => 'Secondname', 'field_name' => 'secondname'),
                     5 => array('visible' =>1, 'name' => 'phone', 'caption' => 'Phone', 'field_name' => 'phone'),
                     6 => array('visible' =>-1, 'name' => 'last_visit', 'caption' => 'NOW()', 'field_name' => 'last_visit'));
        $data = array(
                     'username' => $username,
                     'password' => $password,
                     'email' => $email,
                     'firstname' => $firstname,
                     'secondname' => $secondname,
                     'phone' => $phone);

        $user_id = obj_insert('account', $field_arr, $data);

        if (($secretQ != '') or ($secretA != '')) {
            $field_arr = array(
                         0 => array('visible' =>1, 'name' => 'account', 'caption' => 'Account', 'field_name' => 'account'),
                         1 => array('visible' =>1, 'name' => 'question', 'caption' => 'Secret question', 'field_name' => 'question'),
                         2 => array('visible' =>1, 'name' => 'answer', 'caption' => 'Secret answer', 'field_name' => 'answer'));
            $data = array(
                         'account' => $user_id,
                         'question' => $secretQ,
                         'answer' => $secretA);
            obj_insert('question_answer', $field_arr, $data);
        };

        /*$_SESSION['username'] = $data['username'];
        $_SESSION['firstname'] = $data['firstname'];
        $_SESSION['secondname'] = $data['secondname'];
        $_SESSION['email'] = $data['email'];
        $_SESSION['phone'] = $data['phone'];
        $_SESSION['last_visit'] = date("Y-m-d G:i:s");*/

        $subject = "www.exoticpropertysale.com - Registration";
        $message = "You successfully registered at http://exoticpropertysales.com! \n";
        $message .= "You can login now and add properties to your personal watch list. \n";
        $message .= "Your acconts information:\n";
        $message .= "Username: $username \n";
        $message .= "Password: $password \n";

        mail($email, $subject, $message);

        $reg = true;
    };

    // include for standart blocks (news/locations)
    require_once($lpath['include'].'standart_blocks.php');

    $smarty->assign('account_info', $data);
    $smarty->assign('error', $error_reg);
    $smarty->assign('auth', $reg);
    $smarty->assign('is_forgpswd_form', $is_forgpswd_form);
    $smarty->display('auth.html');

    break;
default:
    // include for standart blocks (news/locations)
    require_once($lpath['include'].'standart_blocks.php');
    $smarty->display('main.html');
    break;
};

?>
