<?php
require_once('.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'session.php');
require_once($lpath['include'].'standart_blocks.php');


$sales_email = "sales@".$lpath['host'];

$err_message = array();

if (!return_variable_from_request('first_name'))
    $err_message [] = 'required first name';

if (!return_variable_from_request('phone'))
    $err_message [] = 'required phone number';

if (!return_variable_from_request('email'))
    $err_message [] = 'required e-mail address';

// get not required vars
return_variable_from_request('surname');
return_variable_from_request('fax');
return_variable_from_request('message');
return_variable_from_request('properties');
$properties = (int) $properties;

$products = get_obj_list("product", array(
    0 => array('visible' =>0, 'field_name' => 'id'),
    1 => array('visible' =>1, 'field_name' => 'name')
));

foreach ($products as $prod)
    $attach_properties[$prod['id']] = $prod['name'];

if ($first_name && $phone && $email) {
    $message = "First name: $first_name\n".
                "Surname: $surname\n".
                "Phone: $phone\n".
                "Fax: $fax\n".
                "E-mail: $email\n\n".
                "Text message:\n$message\n\n";
    if (is_int($properties) && $properties) {
        $field_arr = array (
            0 => array("field_name" => "product.name AS name"),
            1 => array("field_name" => "product.description AS description"),
            2 => array("field_name" => "product.price AS price"),
            3 => array("field_name" => "locations.name AS location"),
            4 => array("field_name" => "product.id AS id")
        );
        $where_arr = array(
            0 => array("field_name" => "product.id", "value" => $properties),
            1 => array("field_name" => "product.location", "value" => "locations.id")
        );
        $my_product = get_obj_list('product, locations', $field_arr, $where_arr, null, 1);
        $my_product = $my_product[0];
        $message .= "Property attached.\n".
                "Name: ".$my_product['name']."\n".
                "Description: ".$my_product['description']."\n".
                "Price: ".$my_product['price']." EU\n".
                "Location: ".$my_product['location']."\n";
    }
    // send the mail
    $mail_sent = mail($sales_email, 'request from '.$lpath['host'], $message);
    if ($mail_sent)
        $smarty->assign('ok_message', 'message was sent');
}

else {
    $smarty->assign('first_name', $first_name);
    $smarty->assign('surname', $surname);
    $smarty->assign('phone', $phone);
    $smarty->assign('fax', $fax);
    $smarty->assign('email', $email);
    $smarty->assign('message', $message);
    $smarty->assign('properties', $properties);
}

$smarty->assign('meta', get_meta('contact'));

$smarty->assign('attach_properties', $attach_properties);
$smarty->assign('title', 'Contact Us');
$smarty->assign('err_message', $err_message);
$smarty->display('page.html');

?>
