<?
/**************************** 
* $RCSfile: dbmod.php,v $
* $Author: sergey $ (last committer) 
* $Date: 2006/03/29 09:13:46 $ 
* $Revision: 1.27 $ 
****************************/
//         
// : 'Sergey Kalchenko <S.Kalchenko@infocreek.com>'

if (!@$_SLASHES_CLEAN && get_magic_quotes_gpc()) {
	function _arrayStripSlashes(&$array) {
		foreach($array as $key => $val) {
			if (is_array($val)) {
				_arrayStripSlashes($array[$key]);
			} else {
				$array[$key] = stripslashes($val);
			}
		}
	}
	_arrayStripSlashes($_POST);
	_arrayStripSlashes($_REQUEST);
	_arrayStripSlashes($_GET);
	_arrayStripSlashes($_COOKIE);
	$_SLASHES_CLEAN = true;
}

//    ,    DBX
class dbmod_res {
	var $handle;
	var $rows;
	var $cols;
	var $info;
	var $data;

	function dbmod_res() {
		$this->handle = false;
		$this->rows   = -1;
		$this->cols   = -1;
		$this->info   = array();
		$this->data   = array();
	}
}

// : dbmod_query($mod, $query, $file, $line, $debug)
//       
// : mod   -  ;
//            query -  ;
//            $file -      ; ( __FILE__)
//            $line -       ; ( __LINE__)
//            debug -  :
//                    <  0 -       ;
//                    =  0 -   ;
//                    >  0 -    ;
//                    (     :
//                     $ldebug['query']).
//        ,
//   :
//           $$mod['db_type'] -   ;
//           $$mod['db_host'] -    ;
//           $$mod['db_base'] -   ;
//           $$mod['db_user'] -    ;
//           $$mod['db_pass'] -       ;
//           $$mod['db_info'] -  .
//     $$mod['db_conn'] -    .
//    :
//           $res->handle -       ;
//           $res->rows   -  ;
//           $res->cols   -  ;
//           $res->info   -      , :
//           $res->info['name'] -   ,  ;
//           $res->info['type'] -   ,  ;
//           $res->info['ins_id'] -    ;
//           $res->info['error']  -  ;
//           $res->data   -    
//                          ( : $res->data[<>]['<_>']);
//         .   PHP 
//             DBX .
function dbmod_query($mod, $query, $file=NULL, $line=NULL, $debug=NULL) {
	global $$mod, $ldebug;
	$lmod = &$$mod;       // local module reference

	if (!isset($debug))
		$debug = $ldebug['query'];

	$i = gettimeofday();
	$beg = $i['sec'] + $i['usec']/1000000;

/*	if (function_exists('dbx_query')) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = dbx_connect($lmod['db_type'], $lmod['db_host'],
			                               $lmod['db_base'], $lmod['db_user'],
			                               $lmod['db_pass'], DBX_PERSISTENT)
			       or error_log($mod . ': ' . dbx_error($lmod['db_conn']), 0);
		}
		if ($lmod['db_conn']) {
			$res = dbx_query($lmod['db_conn'], $query, DBX_RESULT_ASSOC | DBX_COLNAMES_UNCHANGED | DBX_RESULT_INFO)
			           or error_log($mod . ': ' . dbx_error($lmod['db_conn']), 0);
			if ($res) {
				if (($lmod['db_type'] == DBX_MYSQL) || ($lmod['db_type'] == 'mysql')) {
					if ($res->cols <= 0) {
						$res->rows = @mysql_affected_rows($lmod['db_conn']->handle);
						$res->info['ins_id'] = @mysql_insert_id($lmod['db_conn']->handle);
						echo 'ins_id='.@mysql_insert_id($lmod['db_conn']->handle).'<br>';
					} else {
						$res->info['ins_id'] = 0;
					}
					print_r($res->info);
				} else if (($lmod['db_type'] == DBX_PGSQL) || ($lmod['db_type'] == 'pgsql')) {
					if ($res->cols <= 0)
						$res->rows = @pg_affected_rows($lmod['db_conn']->handle);
					$res->info['ins_id'] = @pg_last_oid($lmod['db_conn']->handle);
				}
			} else {
				$res = new dbmod_res();
				$res->info['error'] = dbx_error($lmod['db_conn']);
			}
		}
	} else */ if (($lmod['db_type'] == DBX_MYSQL) || ($lmod['db_type'] == 'mysql')) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = @mysql_pconnect($lmod['db_host'], $lmod['db_user'], $lmod['db_pass'])
			       or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			$ver = @explode('.', @mysql_get_server_info($lmod['db_conn']));
			if (is_array($ver)) {
				if (((intval($ver[0]) == 4) && (intval($ver[1]) >= 1)) || (intval($ver[0]) > 4)) {
					@mysql_query("SET SESSION collation_connection='".$lmod['db_info']."'", $lmod['db_conn'])
						or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				}
			}
			if ($lmod['db_charset']) {
				@mysql_query("SET SESSION character_set_client='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				@mysql_query("SET SESSION character_set_connection='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				@mysql_query("SET SESSION character_set_results='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			}
			if ($lmod['db_collation']) {
				@mysql_query("SET SESSION collation_connection='".$lmod['db_collation']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			}
			@mysql_select_db($lmod['db_base'], $lmod['db_conn'])
			       or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
		}

		if ($lmod['db_conn']) {
			$res = new dbmod_res();
			$res->handle = @mysql_query($query, $lmod['db_conn'])
			           or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			if ($res->handle) {
				$res->rows = @mysql_num_rows($res->handle);
				$res->cols = @mysql_num_fields($res->handle);
				$res->info['name'] = array();
				$res->info['type'] = array();
				for ($i=0; $i<$res->cols; ++$i) {
					$res->info['name'][] = @mysql_field_name($res->handle, $i);
					$res->info['type'][] = @mysql_field_type($res->handle, $i);
				}
				while ($row = @mysql_fetch_array($res->handle, MYSQL_ASSOC))
					$res->data[] = $row;
				@mysql_data_seek($res->handle, 0);
			}
			$res->info['error'] = @mysql_error($lmod['db_conn']);

			if (!$res->info['error']) {
				if ($res->cols <= 0)
					$res->rows = @mysql_affected_rows($lmod['db_conn']);
				$res->info['ins_id'] = @mysql_insert_id($lmod['db_conn']);
			}
		}
	} /*else if (($lmod['db_type'] == DBX_PGSQL) || ($lmod['db_type'] == 'pgsql')) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = @pg_pconnect("host={$lmod['db_host']} user={$lmod['db_user']}".
			                                " password={$lmod['db_pass']} dbname={$lmod['db_base']}")
			       or error_log($mod . ': ' . @pg_last_error($lmod['db_conn']), 0);
		}
		if ($lmod['db_conn']) {
			$res = new dbmod_res();
			$res->handle = @pg_query($lmod['db_conn'], $query)
			           or error_log($mod . ': ' . @pg_last_error($lmod['db_conn']), 0);
			if ($res->handle) {
				$res->rows = @pg_num_rows($res->handle);
				$res->cols = @pg_num_fields($res->handle);
				$res->info['name'] = array();
				$res->info['type'] = array();
				for ($i=0; $i<$res->cols; ++$i) {
					$res->info['name'][] = @pg_field_name($res->handle, $i);
					$res->info['type'][] = @pg_field_type($res->handle, $i);
				}
				while ($row = @pg_fetch_assoc($res->handle))
					$res->data[] = $row;
				@pg_result_seek($res->handle, 0);
				if ($res->cols <= 0)
					$res->rows = @pg_affected_rows($res->handle);
				$res->info['ins_id'] = @pg_last_oid($res->handle);
			}
			$res->info['error'] = @pg_last_error($lmod['db_conn']);
		}
	} */
	if (($debug < 0) || ($debug && $res->info['error'])) {         //    :)
		if ($file || $line) {
			echo $file;
			if ($line)
				printf('(%d)', $line);
			echo ': ';
		}
		echo "<b>$mod</b>: db_type='".$lmod['db_type']."', ";
		echo "db_host='".$lmod['db_host']."', db_base='".$lmod['db_base']."', ";
		echo "db_user='".$lmod['db_user']."', db_pass=".($lmod['db_pass'] ? 'YES' : 'NO')."<br>\n";
		echo "<b>Query:</b> '$query'<br>\n";
		echo '<b>Res:</b> cols='.$res->cols.', rows='.$res->rows.', ins_id='.$res->info['ins_id'].',';
		$i = gettimeofday();
		printf('time: %.6f sec,', ($i['sec'] + $i['usec']/1000000) - $beg);
		echo " error='".$res->info['error']."'<br>\n";
		echo "---------------------------------<br>\n";
	}
	return $res;
}

// : dbmod_escape($mod, $text)
//     $text
// : mod  -  ;
//            text -  ;
//            type -  :
//                   'str'     -     ,
//                   'bytea'   -     ( Postgress),
//                   'unbytea' -     ( Postgress).
//        ,
//   :
//           $$mod['db_type'] -   ;
//           $$mod['db_host'] -    ;
//           $$mod['db_base'] -   ;
//           $$mod['db_user'] -    ;
//           $$mod['db_pass'] -       .
//     $$mod['db_conn'] -    .
//          .
function dbmod_escape($mod, $text, $type='str') {
	global $$mod;
	$lmod = &$$mod;       // local module reference
	/* if (function_exists('dbx_escape_string')) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = dbx_connect($lmod['db_type'], $lmod['db_host'],
			                               $lmod['db_base'], $lmod['db_user'],
			                               $lmod['db_pass'], DBX_PERSISTENT)
			       or error_log($mod . ': ' . dbx_error($lmod['db_conn']), 0);
		}
		if ($lmod['db_conn']) {
			$res = dbx_escape_string($lmod['db_conn'], $text)
			           or error_log($mod . ': ' . dbx_error($lmod['db_conn']), 0);
		}
	} else */ if (($lmod['db_type'] == DBX_MYSQL) || ($lmod['db_type'] == 'mysql')) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = @mysql_pconnect($lmod['db_host'], $lmod['db_user'], $lmod['db_pass'])
			       or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			$ver = @explode('.', @mysql_get_server_info($lmod['db_conn']));
			if (is_array($ver)) {
				if (((intval($ver[0]) == 4) && (intval($ver[1]) >= 1)) || (intval($ver[0]) > 4)) {
					@mysql_query("SET SESSION collation_connection='".$lmod['db_info']."'", $lmod['db_conn'])
						or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				}
			}
			if ($lmod['db_charset']) {
				@mysql_query("SET SESSION character_set_client='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				@mysql_query("SET SESSION character_set_connection='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
				@mysql_query("SET SESSION character_set_results='".$lmod['db_charset']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			}
			if ($lmod['db_collation']) {
				@mysql_query("SET SESSION collation_connection='".$lmod['db_collation']."'", $lmod['db_conn'])
					or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
			}
			@mysql_select_db($lmod['db_base'], $lmod['db_conn'])
			       or error_log($mod . ': ' . @mysql_error($lmod['db_conn']), 0);
		}

		if ($lmod['db_conn']) {
			$res = function_exists('mysql_real_escape_string') ?
					@mysql_real_escape_string($text, $lmod['db_conn']) :
					@mysql_escape_string($text);
		}
	} /*else if (($lmod['db_type'] == DBX_PGSQL) || ($lmod['db_type'] == "pgsql")) {
		if (!$lmod['db_conn']) {
			$lmod['db_conn'] = @pg_pconnect("host={$lmod['db_host']} user={$lmod['db_user']}".
			                                " password={$lmod['db_pass']} dbname={$lmod['db_base']}")
			       or error_log($mod . ': ' . @pg_last_error($lmod['db_conn']), 0);
		}
		if ($lmod['db_conn']) {
			if ($type == 'str') {
				$res = @pg_escape_string($text);
			} else if ($type == 'bytea') {
				$res = @pg_escape_bytea($text);
			} else if ($type == 'unbytea') {
				$res = @pg_unescape_bytea($text);
			} else {
				$res = $text;
			}
		}
	}  */
	return $res;
}
?>
