<?php
require_once('../.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'HTML/QuickForm.php');
require_once($lpath['common'].'HTML/QuickForm/Renderer/ArraySmarty.php');

$image_path = $lpath['www'].'pictures/prod/';

if (isset($_POST['action']) or isset($_GET['action']))  {
    if (isset($_POST['action']))  {
        $action=$_POST['action'];
    } elseif (isset($_GET['action'])) {
        $action=$_GET['action'];
    };
} else { header("Location: http://exotic.demoweblab.com/"); exit; }

if (isset($_POST['id']) or isset($_GET['id'])) {
    if (isset($_POST['id']))
        $obj_id = (int) $_POST['id'];
    elseif (isset($_GET['id']))
        $obj_id = (int) $_GET['id'];
} else { header("Location: http://exotic.demoweblab.com/"); exit; }

switch ($action) {
case 'del_product':

    $title = "delete product";

    $form = new HTML_QuickForm('frmDelProduct', 'post', 'delete.php');

    if ($form->isSubmitted() && $form->validate()) {
        $res = product_delete($obj_id);
        if (!$res) {
            $smarty->assign('message', 'product deleted!');

            unset($form);
            $form = new HTML_QuickForm('frmListProduct', 'get', 'list.php');
            $form->addElement('hidden', 'action', 'get_list_product');
            $form->addElement('submit', 'btnSubmit', 'OK', 'class="button"');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        $smarty->assign('message', $title." ".$_GET['product_name'].' ?');

        // adding basic form elements
        $form->addElement('hidden', 'action', $action);
        $form->addElement('hidden', 'id', $obj_id);

        $form->addElement('submit', 'btnSubmit', 'Delete', 'class="button"');
    }
    break;

case 'del_category':
    $title = "delete category";

    $form = new HTML_QuickForm('frmDelCategory', 'post', 'delete.php');

    if ($form->isSubmitted() && $form->validate()) {
        $res = category_delete($obj_id);
        if (!$res) {
            $smarty->assign('message', 'category deleted!');

            unset($form);
            $form = new HTML_QuickForm('frmListCategory', 'get', 'list.php');
            $form->addElement('hidden', 'action', 'get_list_category');
		    $form->addElement('submit', 'btnSubmit', 'OK', 'class="button"');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        $smarty->assign('message', $title." ".$_GET['category_name'].' ?');

        // adding basic form elements
        $form->addElement('hidden', 'action', $action);
        $form->addElement('hidden', 'id', $obj_id);

        $form->addElement('submit', 'btnSubmit', 'Delete', 'class="button"');
    }

    break;

case 'del_property_value':
    $title = 'delete property for product';
    break;

case 'del_property':
    $title = 'delete property';

    $form = new HTML_QuickForm('frmDelProperty', 'post', 'delete.php');

    if ($form->isSubmitted() && $form->validate()) {
        $res = property_delete($obj_id);
        if (!$res) {
            $smarty->assign('message', 'property deleted!');

            unset($form);
            $form = new HTML_QuickForm('frmListProperty', 'get', 'list.php');
            $form->addElement('hidden', 'action', 'get_list_property');
            $form->addElement('submit', 'btnSubmit', 'OK', 'class="button"');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        $smarty->assign('message', $title." ".$_GET['property_name'].' ?');

    	// adding basic form elements
        $form->addElement('hidden', 'action', $action);
        $form->addElement('hidden', 'id', $obj_id);

        $form->addElement('submit', 'btnSubmit', 'Delete', 'class="button"');
    }
    break;

case 'del_locations':

    $title = "delete location";

    $form = new HTML_QuickForm('frmDelLocation', 'post', 'delete.php');

    if ($form->isSubmitted() && $form->validate()) {
        $res = location_delete($obj_id);
        if (!$res) {
            $smarty->assign('message', 'location deleted!');

            unset($form);
            $form = new HTML_QuickForm('frmListLocation', 'get', 'list.php');
            $form->addElement('hidden', 'action', 'get_list_locations');
            $form->addElement('submit', 'btnSubmit', 'OK', 'class="button"');
        }
        else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        $smarty->assign('message', $title." ".$_GET['locations_name'].' ?');

        // adding basic form elements
        $form->addElement('hidden', 'action', $action);
        $form->addElement('hidden', 'id', $obj_id);

        $form->addElement('submit', 'btnSubmit', 'Delete', 'class="button"');
    };
    break;
default:
    die("Don't use this function!!!");
    break;
};

// Create the renderer object
$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($Smarty);

// set custom error message
$renderer->setRequiredTemplate('{if $error} <span class="error">{$span}</span> {else} <span class="required">{$span}</span>{/if}');
$renderer->setErrorTemplate('{if $error} <span class="error">{$span}</span>{/if}{$html}');

// build the HTML for the form
$form->accept($renderer);

// assign title to page
$smarty->assign('title', $title);

// assign array with form data
$smarty->assign('form_data', $renderer->toArray());

// parse and display the template
$smarty->display('admin/delete.html');
//$form->display();

?>
