<?php
require_once('.locations.inc.php');
require_once($lpath['include'].'config.php');
require_once($lpath['common'].'dbmod.php');
require_once($lpath['include'].'sql.php');
require_once($lpath['include'].'main_function.php');
require_once($lpath['common'].'smarty_config.php');
require_once($lpath['common'].'session.php');
require_once($lpath['include'].'standart_blocks.php');


$err_message = array();

if (!return_variable_from_request('friend_email'))
    $err_message [] = 'required your friend e-mail';

if (!return_variable_from_request('name'))
    $err_message [] = 'required your name';

if (!return_variable_from_request('email'))
    $err_message [] = 'required your e-mail address';

// get not required vars
return_variable_from_request('mymessage');
return_variable_from_request('properties');
$properties = (int) $properties;

$products = get_obj_list("product", array(
    0 => array('visible' =>0, 'field_name' => 'id'),
    1 => array('visible' =>1, 'field_name' => 'name')
));

foreach ($products as $prod)
    $attach_properties[$prod['id']] = $prod['name'];

if ($friend_email && $name && $email) {
    $message = '<p>Your friend has recommended this property from <a href="http://www.exoticpropertysales.com">www.exoticpropertysales.com</a></p>'."\n<br>";
    $message .= "Friend name: $name\n<br>".
                "friend e-mail: $email\n\n<br>".
                "Text message:\n$mymessage\n\n<br>";
    if (is_int($properties) && $properties) {
        $field_arr = array (
            0 => array("field_name" => "product.name AS name"),
            1 => array("field_name" => "product.description AS description"),
            2 => array("field_name" => "product.price AS price"),
            3 => array("field_name" => "locations.name AS location"),
            4 => array("field_name" => "product.id AS id")
        );
        $where_arr = array(
            0 => array("field_name" => "product.id", "value" => $properties),
            1 => array("field_name" => "product.location", "value" => "locations.id")
        );
        $my_product = get_obj_list('product, locations', $field_arr, $where_arr, null, 1);
        $my_product = $my_product[0];
        $message .= "Property attached.\n".
                "<b>Name:</b> ".$my_product['name']." <a href='http://".$lpath['url']."/main.php?action=get_prod&prod_id=".$my_product['id']."&print=1'>see on site</a>\n <br>".
                "<b>Description:</b><br> ".$my_product['description']."\n <br><br>".
                "<b>Price:</b> ".$my_product['price']." GBP\n <br>".
                "<b>Location:</b> ".$my_product['location']."\n <br>";
    }
    // send the mail
    $mail_sent = mail($friend_email, 'message from '.$name, $message, "From: $email\nContent-Type: text/html; charset=iso-8859-1");
    if ($mail_sent)
        $smarty->assign('ok_message', 'message was sent');
}

else {
    $smarty->assign('name', $name);
    $smarty->assign('email', $email);
    $smarty->assign('friend_email', $friend_email);
    $smarty->assign('friend_name', $friend_name);
    $smarty->assign('message', $message);
    $smarty->assign('properties', $properties);
}

$smarty->assign('meta', get_meta('send2friend'));

$smarty->assign('attach_properties', $attach_properties);
$smarty->assign('title', 'Send to friend');
$smarty->assign('err_message', $err_message);
$smarty->display('page.html');

?>
